!function(e,n){"object"==typeof exports&&"object"==typeof module?module.exports=n():"function"==typeof define&&define.amd?define([],n):"object"==typeof exports?exports.CKEditor5=n():(e.CKEditor5=e.CKEditor5||{},e.CKEditor5.bbutton=n())}(self,(()=>(()=>{var __webpack_modules__={"./js/ckeditor5_plugins/bbutton/src/bbuttoncommand.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ BButtonCommand)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/core */ \"ckeditor5/src/core.js\");\n/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ \"./js/ckeditor5_plugins/bbutton/src/utils.js\");\n/**\n * @file\n * Defines the BButtonCommand plugin.\n */\n\n\n\n\n/**\n * The bButton command.\n *\n * @extends module:core/command~Command\n */\nclass BButtonCommand extends ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__.Command {\n\n  /**\n   * @inheritDoc\n   */\n  refresh() {\n    // Toolbar button is always enabled.\n    this.isEnabled = true;\n\n    // Init the empty command value.\n    this.value = null;\n\n    // Find the element in the selection.\n    const { selection } = this.editor.model.document;\n    const El = (0,_utils__WEBPACK_IMPORTED_MODULE_1__.findElement)(selection, 'bButton');\n    if (!El) {\n      return;\n    }\n\n    // Populate command value.\n    this.value = {};\n\n    // Process bButton attributes\n    for (const [attrKey, attrValue] of El.getAttributes()) {\n      this.value[attrKey] = attrValue;\n    }\n\n    // Process bButton children\n    for (const childNode of El.getChildren()) {\n      const childTextNode = childNode.getChild(0);\n      const dataNotEmpty = childTextNode && childTextNode._data;\n      this.value[childNode.name] = dataNotEmpty ? childTextNode._data : childNode.getAttribute('value');\n    }\n  }\n\n  /**\n   * @inheritDoc\n   */\n  execute(values) {\n    const { model } = this.editor;\n\n    model.change((writer) => {\n      // Find an existing bButton if it is being edited.\n      var El = (0,_utils__WEBPACK_IMPORTED_MODULE_1__.findElement)(model.document.selection, 'bButton');\n      if (El) {\n        writer.remove(El);\n      }\n\n      // Create a new button.\n      El = writer.createElement('bButton');\n      // Editing the model element and its children to match the form values.\n      this._editElement(writer, El, values);\n      // Insert a new button.\n      model.insertContent(El);\n    });\n  }\n\n  /**\n   * (Re)create a bButton element using the new values.\n   *\n   * While editing, removes child elements, recreates them\n   * and appends in a proper order.\n   *\n   * @param {Writer} writer\n   *   Model writer.\n   * @param {module:engine/model/element~Element} modelEl\n   *   Model element.\n   * @param {Array} values\n   *   New values.\n   *\n   * @private\n   */\n  _editElement(writer, modelEl, values) {\n    // Clear modelEl attributes.\n    writer.clearAttributes(modelEl);\n\n    // Set modelEl attributes.\n    var modelAttrs = {};\n    modelAttrs.bbLinkUrl = values['bbLinkUrl'];\n    modelAttrs.bbLinkClass = values['bbLinkClass'];\n    modelAttrs.bbTarget = values['bbTarget'];\n    modelAttrs.bbGLeft = values['bbGLeft'];\n    modelAttrs.bbGRight = values['bbGRight'];\n    modelAttrs.bbFALeft = values['bbFALeft'];\n    modelAttrs.bbFARight = values['bbFARight'];\n\n    const textFormatSettings = this.editor.config.get('c5bb')\n    for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n      modelAttrs['bbSelector_' + index] = values['bbSelector_' + index];\n    }\n\n    writer.setAttributes(modelAttrs, modelEl);\n\n    // Get modelEl children elements names.\n    const children = [];\n    Array.from(modelEl.getChildren()).forEach((el) => {\n      children.push(el.name);\n    });\n\n    // Get or create child elements.\n    const bbFARight = this._processChildAttrEl(writer, values, children, modelEl, 'bbFARight');\n    const bbGRight = this._processChildAttrEl(writer, values, children, modelEl, 'bbGRight');\n    const bbLinkText = this._processChildTextEl(writer, values, children, modelEl, 'bbLinkText');\n    const bbGLeft = this._processChildAttrEl(writer, values, children, modelEl, 'bbGLeft');\n    const bbFALeft = this._processChildAttrEl(writer, values, children, modelEl, 'bbFALeft');\n\n    // Append child element in a proper order.\n    if (bbFALeft) {\n      writer.append(bbFALeft, modelEl);\n    }\n    if (bbGLeft) {\n      writer.append(bbGLeft, modelEl);\n    }\n    if (bbLinkText) {\n      writer.append(bbLinkText, modelEl);\n    }\n    if (bbGRight) {\n      writer.append(bbGRight, modelEl);\n    }\n    if (bbFARight) {\n      writer.append(bbFARight, modelEl);\n    }\n  }\n\n  /**\n   * Processes child text elements.\n   *\n   * @param {Writer} writer\n   *   Model writer.\n   * @param {Array} values\n   *   New values.\n   * @param {Array} children\n   *   Child elements names array.\n   * @param {module:engine/model/element~Element} modelEl\n   *   Model element.\n   * @param {string} childElName\n   *   Processed child element name.\n   *\n   * @returns {null|*}\n   *   Child element to append to modelEl, or null.\n   *\n   * @private\n   */\n  _processChildTextEl(writer, values, children, modelEl, childElName) {\n\n    const childEl = this._processChildElement(\n      writer,\n      values[childElName],\n      children,\n      modelEl,\n      childElName\n    );\n\n    if (childEl) {\n      // Remove existing text if any.\n      while (childEl.childCount) {\n        const textNode = childEl.getChild(childEl.childCount - 1);\n        if (textNode) {\n          writer.remove(textNode);\n        }\n      }\n\n      // Set new text.\n      writer.appendText( values[childElName], childEl );\n      return childEl;\n    }\n\n    return null;\n  }\n\n  /**\n   * Processes child attribute elements.\n   *\n   * @param {Writer} writer\n   *   Model writer.\n   * @param {Array} values\n   *   New values.\n   * @param {Array} children\n   *   Child elements names array.\n   * @param {module:engine/model/element~Element} modelEl\n   *   Model element.\n   * @param {string} childElName\n   *   Processed child element name.\n   *\n   * @returns {null|*}\n   *   Child element to append to modelEl, or null.\n   *\n   * @private\n   */\n  _processChildAttrEl(writer, values, children, modelEl, childElName) {\n\n    const childEl = this._processChildElement(\n      writer,\n      values[childElName],\n      children,\n      modelEl,\n      childElName\n    );\n\n    if (childEl) {\n      return childEl;\n    }\n\n    return null;\n  }\n\n  /**\n   * Processes any child element.\n   *\n   * @param {Writer} writer\n   *   Model writer.\n   * @param {string} value\n   *   New values.\n   * @param {Array} children\n   *   Child elements names array.\n   * @param {module:engine/model/element~Element} modelEl\n   *   Model element.\n   * @param {string} childElName\n   *   Processed child element name.\n   *\n   * @returns {null|*}\n   *   Child element to append to modelEl, or null.\n   *\n   * @private\n   */\n  _processChildElement (writer, value, children, modelEl, childElName) {\n\n    // Define an operation.\n    const create = value && !children.includes(childElName);\n    const edit = value && children.includes(childElName);\n    const remove = !value && children.includes(childElName);\n\n    var childEl = null;\n\n    if (create) {\n      childEl = writer.createElement(childElName, { value });\n    } else if (edit || remove) {\n      // Get updated children list to get the correct index.\n      let childrenUpdated = [];\n      Array.from(modelEl.getChildren()).forEach((el) => {\n        childrenUpdated.push(el.name);\n      });\n\n      // Find child element;\n      var childElIndex = childrenUpdated.indexOf(childElName);\n      childEl = modelEl.getChild(childElIndex);\n    }\n\n    // Remove now and re-add later if needed\n    // to comply with the child elements order.\n    if (children.includes(childElName) && childEl) {\n      writer.remove(childEl);\n    }\n\n    if (remove) {\n      return null;\n    } else {\n      return childEl;\n    }\n\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/bbuttoncommand.js?")},"./js/ckeditor5_plugins/bbutton/src/bbuttonediting.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ BButtonEditing)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/core */ \"ckeditor5/src/core.js\");\n/* harmony import */ var _bbuttoncommand__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./bbuttoncommand */ \"./js/ckeditor5_plugins/bbutton/src/bbuttoncommand.js\");\n/* harmony import */ var _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ui/classcollection */ \"./js/ckeditor5_plugins/bbutton/src/ui/classcollection.js\");\n/**\n * @file\n * Defines the BButtonEditing plugin.\n */\n\n/**\n * @module bButton/BButtonEditing\n */\n\n\n\n\n\n/**\n * The editing feature.\n *\n * It introduces the 'bButton' element in the model.\n *\n * @extends module:core/plugin~Plugin\n */\nclass BButtonEditing extends ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__.Plugin {\n\n  /**\n   * @inheritDoc\n   */\n  init() {\n    this._defineSchema();\n    this._defineConverters();\n\n    const editor = this.editor;\n\n    // Attaching the command to the editor.\n    editor.commands.add(\n      'bButton',\n      new _bbuttoncommand__WEBPACK_IMPORTED_MODULE_1__[\"default\"](this.editor),\n    );\n  }\n\n  /**\n   * Registers schema for bbutton and its child elements.\n   *\n   * @private\n   */\n  _defineSchema() {\n    const schema = this.editor.model.schema;\n    const textFormatSettings = this.editor.config.get('c5bb')\n    const customAttributes = [];\n    for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n      customAttributes.push('bbSelector_' + index);\n    }\n\n    // parent element.\n    schema.register('bButton', {\n      inheritAllFrom: '$inlineObject',\n      allowAttributes: [\n        'bbLinkUrl',\n        ...customAttributes,\n        'bbTarget',\n        // Needed to avoid conflicts with the 'linkClass' model attribute.\n        'bbLinkClass'\n      ],\n      allowChildren: [\n        'bbGLeft',\n        'bbGRight',\n        'bbFALeft',\n        'bbFARight',\n        'bbLinkText',\n      ],\n    });\n\n    // child elements.\n    schema.register('bbLinkText', {\n      allowIn: 'bButton',\n      isLimit: true,\n      allowContentOf: '$block',\n    });\n    schema.register('bbGLeft', {\n      allowIn: 'bButton',\n      isLimit: true,\n      allowContentOf: '$block',\n      allowAttributes: ['value']\n    });\n    schema.register('bbGRight', {\n      allowIn: 'bButton',\n      isLimit: true,\n      allowContentOf: '$block',\n      allowAttributes: ['value']\n    });\n    schema.register('bbFALeft', {\n      allowIn: 'bButton',\n      isLimit: true,\n      allowContentOf: '$block',\n      allowAttributes: ['value']\n    });\n    schema.register('bbFARight', {\n      allowIn: 'bButton',\n      isLimit: true,\n      allowContentOf: '$block',\n      allowAttributes: ['value']\n    });\n  }\n\n  /**\n   * Defines converters.\n   */\n  _defineConverters() {\n    const {conversion} = this.editor;\n    const textFormatSettings = this.editor.config.get('c5bb')\n\n    // bButton. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'a',\n        classes: [ 'btn' ]\n      },\n      converterPriority: 'highest',\n      model: (viewElement, conversionApi ) => {\n        // Do not convert if the link does not have the 'btn' class.\n        let classes = viewElement.getAttribute('class');\n        if (!classes) {\n          return null;\n        }\n        classes = classes.split(' ');\n        if (!classes.includes('btn')) {\n          return null;\n        }\n\n        var attrs = {\n          bbLinkUrl: viewElement.getAttribute('href'),\n          bbLinkClass: classes.join(' '),\n          bbTarget: viewElement.getAttribute('target') ?? '',\n        };\n\n        for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n          attrs['bbSelector_' + index] = '';\n          textFormatSettings.selectors[index].options.forEach((elm) => {\n            if (classes.includes(elm.value)) {\n              attrs['bbSelector_' + index] = elm.value;\n            }\n          })\n        }\n\n        return conversionApi.writer.createElement( 'bButton', attrs );\n      },\n    });\n\n    // two next upcasts has only purpose to override\n    // core Link conversions\n    conversion.for('upcast').attributeToAttribute({\n      view: {\n        name: 'a',\n        attributes: {\n          ['href']: true\n        }\n      },\n      model: {\n        key: 'bbLinkUrl',\n        value: viewElement => {\n          return viewElement.getAttribute('href');\n        }\n      },\n    });\n\n    // Needed to avoid conflicts with the 'linkClass' model attribute\n    // bound to the same HTML \"class\" attribute.\n    conversion.for('upcast').attributeToAttribute({\n      view: {\n        name: 'a',\n        attributes: {\n          ['class']: true\n        }\n      },\n      model: {\n        key: 'bbLinkClass',\n        value: viewElement => {\n          return viewElement.getAttribute('class');\n        }\n      },\n    });\n\n    // bButton. Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bButton',\n      view: (modelElement, { writer }) => {\n        const classes = ['btn'];\n\n        for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n          if (modelElement.getAttribute('bbSelector_' + index)) {\n            classes.push(modelElement.getAttribute('bbSelector_' + index))\n          }\n        }\n\n        var htmlAttrs = {\n          'class': classes.join(' '),\n          'href': modelElement.getAttribute('bbLinkUrl'),\n        };\n\n        if (modelElement.getAttribute('bbTarget')) {\n          htmlAttrs.target = modelElement.getAttribute('bbTarget');\n        }\n\n        return writer.createContainerElement('a', htmlAttrs);\n      }\n    });\n\n    // bButtonText. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'span',\n        classes: textFormatSettings.textClass,\n      },\n      model: ( _, { writer } ) => {\n        return writer.createElement('bbLinkText');\n      }\n    });\n\n    // Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bbLinkText',\n      view: ( _, { writer: viewWriter } ) => {\n        return viewWriter.createContainerElement('span', textFormatSettings.textClass\n          ? {class: textFormatSettings.textClass}\n          : {}\n        );\n      }\n    });\n\n    // bbFALeft. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'em',\n        classes: ['fa', 'fontawesome-icon-left'],\n      },\n      converterPriority: 'highest',\n      model: ( viewElement, { writer } ) => {\n        if (!viewElement.getAttribute('class')) return null;\n        const classes = (new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"]()).addFromString(viewElement.getAttribute('class'));\n        if (!classes.has('fa') || !classes.has('fontawesome-icon-left')) {\n          return null;\n        }\n\n        var attrs = {\n          value: classes.remove('fa').remove('fontawesome-icon-left').getClassName()\n        };\n        return writer.createElement( 'bbFALeft', attrs );\n      }\n    });\n\n    // Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bbFALeft',\n      view: ( modelElement, { writer: viewWriter } ) => {\n        const classes = new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"](['fa', 'fontawesome-icon-left']);\n        if (modelElement.getAttribute('value')) {\n          classes.addFromString(modelElement.getAttribute('value'));\n        }\n        return viewWriter.createAttributeElement('em', { class: classes.getClassName() });\n      }\n    });\n\n    // bbFARight. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'em',\n        classes: ['fa', 'fontawesome-icon-right'],\n      },\n      model: ( viewElement, { writer } ) => {\n        if (!viewElement.getAttribute('class')) return null;\n        const classes = (new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"]()).addFromString(viewElement.getAttribute('class'));\n        if (!classes.has('fa') || !classes.has('fontawesome-icon-right')) {\n          return null;\n        }\n\n        var attrs = {\n          value: classes.remove('fa').remove('fontawesome-icon-right').getClassName()\n        };\n        return writer.createElement( 'bbFARight', attrs);\n      }\n    });\n\n    // Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bbFARight',\n      view: ( modelElement, { writer: viewWriter } ) => {\n        const classes = new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"](['fa', 'fontawesome-icon-right']);\n        if (modelElement.getAttribute('value')) {\n          classes.addFromString(modelElement.getAttribute('value'));\n        }\n        return viewWriter.createAttributeElement('em', { class: classes.getClassName() });\n      }\n    });\n\n    // bbGLeft. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'span',\n        classes: ['bs-icon-left', 'glyphicon'],\n      },\n      model: ( viewElement, { writer } ) => {\n        const classesValue = viewElement.getAttribute('class');\n        if (!classesValue) return null;\n        const classes = (new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"]()).addFromString(classesValue);\n        if (!classes.has('glyphicon') || !classes.has('bs-icon-left')) {\n          return null;\n        }\n        const attrs = {\n          value: classes.remove('glyphicon').remove('bs-icon-left').getClassName()\n        };\n        return writer.createElement( 'bbGLeft', attrs);\n      }\n    });\n\n    // Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bbGLeft',\n      view: ( modelElement, { writer: viewWriter } ) => {\n        const classes = new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"](['glyphicon', 'bs-icon-left']);\n        if (modelElement.getAttribute('value')) {\n          classes.addFromString(modelElement.getAttribute('value'));\n        }\n        return viewWriter.createAttributeElement('span', { class: classes.getClassName() });\n      }\n    });\n\n    // bbGRight. View -> Model.\n    conversion.for('upcast').elementToElement({\n      view: {\n        name: 'span',\n        classes: ['bs-icon-right', 'glyphicon'],\n      },\n      model: ( viewElement, { writer } ) => {\n        const classesValue = viewElement.getAttribute('class');\n        if (!classesValue) return null;\n        const classes = (new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"]()).addFromString(classesValue);\n        if (!classes.has('glyphicon') || !classes.has('bs-icon-right')) {\n          return null;\n        }\n        const attrs = {\n          value: classes.remove('glyphicon').remove('bs-icon-right').getClassName()\n        };\n        return writer.createElement( 'bbGRight', attrs);\n      }\n    });\n\n    // Model -> View.\n    conversion.for('downcast').elementToElement({\n      model: 'bbGRight',\n      view: ( modelElement, { writer: viewWriter } ) => {\n        const classes = new _ui_classcollection__WEBPACK_IMPORTED_MODULE_2__[\"default\"](['glyphicon', 'bs-icon-right']);\n        if (modelElement.getAttribute('value')) {\n          classes.addFromString(modelElement.getAttribute('value'));\n        }\n        return viewWriter.createAttributeElement('span', { class: classes.getClassName() });\n      }\n    });\n\n  }\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/bbuttonediting.js?")},"./js/ckeditor5_plugins/bbutton/src/bbuttonui.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ BButtonUI)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/core */ \"ckeditor5/src/core.js\");\n/* harmony import */ var ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ckeditor5/src/ui */ \"ckeditor5/src/ui.js\");\n/* harmony import */ var _icons_bb_svg__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../../icons/bb.svg */ \"./js/icons/bb.svg\");\n/* harmony import */ var _ui_formview__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ui/formview */ \"./js/ckeditor5_plugins/bbutton/src/ui/formview.js\");\n/**\n * @file\n * Defines the BButtonUI plugin.\n */\n\n/**\n * @module bbutton/BButtonUI\n */\n\n\n\n\n\n\n/**\n * The UI plugin. It introduces the `'bButton'` button and the forms.\n *\n * It uses the\n * {@link module:ui/panel/balloon/contextualballoon~ContextualBalloon contextual balloon plugin}.\n *\n * @extends module:core/plugin~Plugin\n */\nclass BButtonUI extends ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__.Plugin {\n\n  /**\n   * @inheritDoc\n   */\n  static get requires() {\n    return [ ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_1__.ContextualBalloon ];\n  }\n\n  /**\n   * @inheritDoc\n   */\n  init() {\n    // Create the balloon.\n    this._balloon = this.editor.plugins.get( ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_1__.ContextualBalloon );\n\n    this._addToolbarButton();\n    this.formView = this._createFormView();\n    this._handleSelection();\n  }\n\n  /**\n   * Adds the toolbar button.\n   *\n   * @private\n   */\n  _addToolbarButton() {\n    const editor = this.editor;\n\n    editor.ui.componentFactory.add('bButton', (locale) => {\n      const buttonView = new ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_1__.ButtonView(locale);\n\n      // Create the toolbar button.\n      buttonView.set({\n        label: editor.t('Bootstrap Button'),\n        icon: _icons_bb_svg__WEBPACK_IMPORTED_MODULE_2__[\"default\"],\n        tooltip: true\n      });\n\n      // Bind button to the command.\n      // The state on the button depends on the command values.\n      const command = editor.commands.get('bButton');\n      buttonView.bind( 'isEnabled' ).to( command, 'isEnabled' );\n      buttonView.bind( 'isOn' ).to( command, 'value', value => !!value );\n\n      // Execute the command when the button is clicked.\n      this.listenTo(buttonView, 'execute', () =>\n        this._showUI(),\n      );\n\n      return buttonView;\n    });\n  }\n\n  /**\n   * Creates the form view.\n   *\n   * @returns {FormView}\n   *   The form view instance.\n   *\n   * @private\n   */\n  _createFormView() {\n    // The FormView defined in src/ui/formview.js\n    const textFormatSettings = this.editor.config.get('c5bb')\n    const formView = new _ui_formview__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.editor.locale, textFormatSettings);\n\n    // Form submit handler.\n    this.listenTo(formView, 'submit', () => {\n      let values = {\n        bbLinkText:   formView.textInputView.fieldView.element.value,\n        bbLinkUrl:    formView.urlInputView.fieldView.element.value,\n        bbLinkClass: 'btn',\n        bbTarget:     formView.targetSelectView.getValue(),\n        bbGLeft:      formView.glyphLeftInputView.fieldView.element.value,\n        bbGRight:     formView.glyphRightInputView.fieldView.element.value,\n        bbFALeft:     formView.faLeftInputView.fieldView.element.value,\n        bbFARight:    formView.faRightInputView.fieldView.element.value,\n      };\n\n      for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n        values['bbSelector_' + index] = formView['selectCustom_' + index].getValue();\n      }\n\n      this.editor.execute('bButton', values);\n\n      // Hide the form view after submit.\n      this._hideUI();\n    });\n\n    // Hide the form view after clicking the \"Cancel\" button.\n    this.listenTo( formView, 'cancel', () => {\n      this._hideUI();\n    } );\n\n\n    // Hide the form view when clicking outside the balloon.\n    (0,ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_1__.clickOutsideHandler)( {\n      emitter: formView,\n      activator: () => this._balloon.visibleView === formView,\n      contextElements: [ this._balloon.view.element ],\n      callback: () => {\n        this._hideUI()\n      }\n    } );\n\n    return formView;\n  }\n\n  /**\n   * Adds the {@link #FormView} to the balloon and sets the form values.\n   *\n   * @private\n   */\n  _addFormView() {\n\n    this._balloon.add({\n      view: this.formView,\n      position: this._getBalloonPositionData(),\n      balloonClassName: 'c5bb_balloon',\n    });\n\n    const command = this.editor.commands.get('bButton');\n\n    const modelToFormFields = {\n      bbTarget:     'targetSelectView',\n      bbGLeft:      'glyphLeftInputView',\n      bbGRight:     'glyphRightInputView',\n      bbFALeft:     'faLeftInputView',\n      bbFARight:    'faRightInputView',\n      bbLinkUrl:    'urlInputView',\n      bbLinkText:   'textInputView',\n    };\n\n    const textFormatSettings = this.editor.config.get('c5bb')\n    for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n      modelToFormFields['bbSelector_' + index] = 'selectCustom_' + index;\n    }\n\n    // Handle text input fields.\n    Object.entries(modelToFormFields).forEach(([modelName, formElName]) => {\n      const formEl = this.formView[formElName];\n      // Needed to display a placeholder of the elements being focused before.\n      formEl.focus();\n\n      const isEmpty = !command.value || !command.value[modelName] || command.value[modelName] === '';\n\n      // Set URL default value.\n      if (modelName === 'bbLinkUrl' && isEmpty) {\n        formEl.fieldView.element.value = '#';\n        formEl.set('isEmpty', false);\n        return;\n      }\n\n      // Set Text default value.\n      if (modelName === 'bbLinkText' && isEmpty) {\n        const selection = this.editor.model.document.selection;\n        const range = selection.getFirstRange();\n        let selectedText = '';\n        for (const item of range.getItems()) {\n          if (item.data) {\n            selectedText += item.data;\n          }\n        }\n\n        if (selectedText.length) {\n          formEl.fieldView.element.value = selectedText;\n          formEl.set('isEmpty', false);\n          return;\n        }\n      }\n\n      let found = false\n      if (isEmpty) {\n        for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n          if (modelName == 'bbSelector_' + index) {\n            formEl.setValue('');\n            found = true;\n            break;\n          }\n        }\n\n        if (!found) {\n          switch (modelName) {\n            case 'bbTarget':\n              formEl.setValue('');\n              break;\n            default:\n              formEl.fieldView.element.value = '';\n          }\n        }\n      } else {\n        for (let index = 0; index < textFormatSettings.selectors.length; index++) {\n          if (modelName == 'bbSelector_' + index) {\n            formEl.setValue(command.value[modelName]);\n            found = true;\n            break;\n          }\n        }\n\n        if (!found) {\n          switch (modelName) {\n            case 'bbTarget':\n              formEl.setValue(command.value[modelName]);\n              break;\n            default:\n              formEl.fieldView.element.value = command.value[modelName];\n          }\n        }\n      }\n      formEl.set('isEmpty', isEmpty);\n\n    });\n\n    // Reset the focus to the first form element.\n    this.formView.focus();\n  }\n\n  /**\n   * Handles the selection specific cases (right before or after the element).\n   *\n   * @private\n   */\n  _handleSelection() {\n    const editor = this.editor;\n\n    this.listenTo(editor.editing.view.document, 'selectionChange', (eventInfo, eventData) => {\n      const selection = editor.model.document.selection;\n\n      let el = selection.getSelectedElement() ?? selection.getFirstRange().getCommonAncestor();\n\n      if (!el.findAncestor('bButton')) {\n        this._hideUI();\n        return;\n      }\n\n      const positionBefore = editor.model.createPositionBefore(el);\n      const positionAfter = editor.model.createPositionAfter(el);\n\n      const position = selection.getFirstPosition();\n\n      const beforeTouch = position.isTouching( positionBefore );\n      const afterTouch = position.isTouching( positionAfter );\n\n      // Handle the \"border\" selection.\n      if ((afterTouch && el.name == 'bbLinkText')\n        || ((afterTouch || beforeTouch) && ['bbFARight', 'bbGRight'].includes(el.name)) ) {\n        editor.model.change(writer => {\n          writer.setSelection(editor.model.createPositionAfter(el.findAncestor('bButton')), 'on');\n        });\n      } else if ((beforeTouch && el.name == 'bbLinkText')\n        || ((afterTouch || beforeTouch) && ['bbFALeft', 'bbGLeft'].includes(el.name)) ) {\n        editor.model.change(writer => {\n          writer.setSelection(editor.model.createPositionBefore(el.findAncestor('bButton')), 'on');\n        });\n      } else {\n        this._showUI();\n      }\n\n    });\n  }\n\n  /**\n   * Shows the UI.\n   *\n   * @private\n   */\n  _showUI() {\n    this._addFormView();\n  }\n\n  /**\n   * Hide the UI.\n   *\n   * @private\n   */\n  _hideUI() {\n    const formView = this.formView;\n\n    // Without this a new form contains the old values.\n    if (formView.element) {\n      formView.element.reset();\n    }\n\n    if (this._balloon.hasView(formView)) {\n      this._balloon.remove(formView);\n    }\n\n    // Focus the editing view after closing the form view.\n    this.editor.editing.view.focus();\n  }\n\n  /**\n   * Gets balloon position.\n   *\n   * @returns {{target: (function(): *)}}\n   *\n   * @private\n   */\n  _getBalloonPositionData() {\n    const view = this.editor.editing.view;\n    const viewDocument = view.document;\n    let target = null;\n\n    // Set a target position by converting view selection range to DOM.\n    target = () => view.domConverter.viewRangeToDom(\n      viewDocument.selection.getFirstRange()\n    );\n\n    return {\n      target\n    };\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/bbuttonui.js?")},"./js/ckeditor5_plugins/bbutton/src/index.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval('__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/core */ "ckeditor5/src/core.js");\n/* harmony import */ var _bbuttonediting__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./bbuttonediting */ "./js/ckeditor5_plugins/bbutton/src/bbuttonediting.js");\n/* harmony import */ var _bbuttonui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./bbuttonui */ "./js/ckeditor5_plugins/bbutton/src/bbuttonui.js");\n/**\n * @file\n * Defines the BButton plugin.\n */\n\n/**\n * @module bbutton/BButton\n */\n\n\n\n\n\n/**\n * The BButton plugin.\n *\n * This is a "glue" plugin that loads\n *\n * @extends module:core/plugin~Plugin\n */\nclass BButton extends ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_0__.Plugin {\n\n  /**\n   * @inheritdoc\n   */\n  static get requires() {\n    return [_bbuttonediting__WEBPACK_IMPORTED_MODULE_1__["default"], _bbuttonui__WEBPACK_IMPORTED_MODULE_2__["default"]];\n  }\n\n  /**\n   * @inheritdoc\n   */\n  static get pluginName() {\n    return \'bButton\';\n  }\n\n}\n\n/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({\n  BButton,\n});\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/index.js?')},"./js/ckeditor5_plugins/bbutton/src/ui/classcollection.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ ClassCollector)\n/* harmony export */ });\n/**\n * @file\n * Defines the ClassCollector class.\n */\n\n/**\n * @module bButton/ui/ClassCollector\n */\n\n/**\n * The ClassCollector class.\n * Encapsulate work with html classes\n */\nclass ClassCollector  {\n    /**\n     * get initial list of class names\n     */\n    constructor( names = [] ) {\n      this.names = new Set( names );\n    }\n\n    /**\n     * Add more names\n     * @namesString string - it will parse all names from given namesString\n     * returns @self for chaining\n     */\n    addFromString( namesString ) {\n      const values = namesString.split(new RegExp('[^\\\\w\\\\d_-]+', 'i'));\n      values.forEach(value => { this.names.add(value); });\n      return this;\n    }\n\n    /**\n     * Check if given name in the SET\n     * returns @boolean\n     */\n    has(name) {\n      return this.names.has(name);\n    }\n\n    /**\n     * Removes given name from the SET\n     * returns @self for chaining\n     */\n    remove(name) {\n      this.names.delete(name);\n      return this;\n    }\n\n    /**\n     * build ClassName\n     * returns @string\n     */\n    getClassName() {\n      if (this.names.has('')) {\n        this.names.delete('');\n      }\n      return [...this.names].sort().join(' ');\n    }\n}\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/ui/classcollection.js?")},"./js/ckeditor5_plugins/bbutton/src/ui/formview.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ FormView)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/ui */ \"ckeditor5/src/ui.js\");\n/* harmony import */ var ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ckeditor5/src/core */ \"ckeditor5/src/core.js\");\n/* harmony import */ var _select_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./select.js */ \"./js/ckeditor5_plugins/bbutton/src/ui/select.js\");\n/* harmony import */ var _tag_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./tag.js */ \"./js/ckeditor5_plugins/bbutton/src/ui/tag.js\");\n/**\n * @file\n * Defines the FormView View class.\n */\n\n/**\n * @module bButton/ui/FormView\n */\n\n\n\n\n\n\n/**\n * The bButton FormView class.\n *\n * This view displays an editing form.\n *\n * @extends module:ui/view~View\n */\nclass FormView extends ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.View {\n\n  /**\n   * @inheritDoc\n   */\n  constructor( locale, customSelectors = [] ) {\n    super( locale );\n\n    // Inputs.\n    this.textInputView = this._createInput('Text', { required: true });\n    this.urlInputView = this._createInput('URL', {required: true});\n\n    // Selectors\n    const selectorsList = [];\n    for (let index = 0; index < customSelectors.selectors.length; index++) {\n      this['selectCustom_' + index] = this._createSelect(\n        customSelectors.selectors[index].label,\n        { options: customSelectors.selectors[index].options });\n      selectorsList.push(this['selectCustom_' + index]);\n    }\n\n    this.targetSelectView = this._createSelect('Target', {options: [\n      {label: 'Not Set', value: ''},\n      {label: 'Frame', value: 'frame'},\n      {label: 'Popup', value: 'popup'},\n      {label: 'New Window (_blank)', value: '_blank'},\n      {label: 'Topmost Window (_top)', value: '_top'},\n      {label: 'Same Window (_self)', value: '_self'},\n      {label: 'Parent Window (_parent)', value: '_parent'},\n    ]});\n\n    // Icon classes\n    this.glyphLeftInputView = this._createInput('Left Icon', { required: false });\n    this.glyphRightInputView = this._createInput('Right Icon', { required: false });\n    this.faLeftInputView = this._createInput('Left Icon', { required: false });\n    this.faRightInputView = this._createInput('Right Icon', { required: false });\n\n    // Create the save button.\n    this.saveButtonView = this._createButton(\n      'Save', ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_1__.icons.check, ['button', 'form-submit', 'ck-button-save']\n    );\n\n    // Triggers the submit event on entire form when clicked.\n    this.saveButtonView.type = 'submit';\n\n    // Create the cancel button.\n    this.cancelButtonView = this._createButton(\n      'Cancel', ckeditor5_src_core__WEBPACK_IMPORTED_MODULE_1__.icons.cancel, ['button', 'form-submit', 'ck-button-cancel']\n    );\n\n    // Delegate ButtonView#execute to FormView#cancel.\n    this.cancelButtonView.delegate( 'execute' ).to( this, 'cancel' );\n\n    let iconsGroup = new ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.CollapsibleView(this.locale, [\n      new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'div', {\n        children: [\n          new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'b', { text: 'Bootstrap Glyphicon'}),\n          new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'br'),\n          'List of Icons,. e.g. glyphicon-pencil'\n        ]\n      }),\n      this.glyphLeftInputView,\n      this.glyphRightInputView,\n      new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'div', {\n        children: [\n          new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'b', { text: 'Font Awesome'}),\n          new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'br'),\n          'List of Icons, e.g. fa-arrow-right, fa-volume-up, fa-play'\n        ]\n      }),\n      this.faLeftInputView,\n      this.faRightInputView,\n    ]);\n    iconsGroup.set('label', 'Icons (Glyph and FA)');\n\n    this.childViewsCollection = this.createCollection([\n      new ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.FormHeaderView(this.locale, { label: 'Bootstrap Buttons'}),\n      new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'div', {\n        attributes: {\n          class: [],\n          tabindex: '-1'\n        },\n        children: [\n          new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'table', {\n            attributes: {\n              width: '100%',\n              cellpadding: '0',\n              cellspacing: '15',\n              style: 'margin: 0'\n            },\n            children: [\n              new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'tr', {\n                children: [\n                  new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'td', {\n                    attributes: {\n                      style: 'vertical-align: top',\n                    },\n                    children: [\n                      this.textInputView,\n                      this.urlInputView,\n                      ...selectorsList,\n                      this.targetSelectView,\n                    ]\n                  }),\n                  new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'td', {\n                    attributes: {\n                      style: 'vertical-align: top',\n                    },\n                    children: customSelectors.showIconSettings == 1\n                      ? [iconsGroup]\n                      : []\n                  }),\n                ]\n              }),\n              new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'tr', {\n                children: [\n                  new _tag_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"](this.locale, 'td', {\n                    attributes: {\n                      style: 'vertical-align: top',\n                      colspan: '2'\n                    },\n                    children: [\n                      this.saveButtonView,\n                      this.cancelButtonView\n                    ]\n                  }),\n                ]\n              })\n            ]\n          }),\n\n        ]\n      })\n    ]);\n\n    this.setTemplate( {\n      tag: 'form',\n      attributes: {\n        class: [ 'ck', 'ck-bbutton-link-form', 'ck-reset_all-excluded' ],\n        // https://github.com/ckeditor/ckeditor5-image/issues/40\n        tabindex: '-1'\n      },\n      children: this.childViewsCollection\n    } );\n\n  }\n\n  /**\n   * @inheritDoc\n   */\n  render() {\n    super.render();\n\n    // Submit the form when the user clicked the save button\n    // or pressed enter in the input.\n    (0,ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.submitHandler)( {\n      view: this\n    } );\n  }\n\n  /**\n   * Focus on the first form element.\n   */\n  focus() {\n    // this.childViewsCollection.get(1).children.get(0).focus();\n  }\n\n  /**\n   * Creates an input field.\n   *\n   * @param {string} label\n   *   Input field label.\n   * @param {object} options\n   *   Options.\n   *\n   * @returns {module:ui/labeledfield/labeledfieldview~LabeledFieldView}\n   *   The labeled field view class instance.\n   *\n   * @private\n   */\n  _createInput(label, options = {}) {\n    const labeledFieldView = new ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.LabeledFieldView(this.locale, ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.createLabeledInputText);\n    labeledFieldView.label = label;\n\n    // Sets the required attribute when needed.\n    if (options.required && options.required === true) {\n      labeledFieldView.fieldView.extendTemplate({\n        attributes: {\n          required: true,\n          class: ['form-text', 'form-element']\n        }\n      });\n    }\n\n    labeledFieldView.setTemplate({\n      tag: 'div',\n      attributes: {\n        class: [ 'form-item' ],\n      },\n      children: [labeledFieldView.template]\n    });\n\n    return labeledFieldView;\n  }\n\n  /**\n   * Creates a select field.\n   *\n   * @param {string} label\n   *   Input field label.\n   * @param {object} options\n   *   Options.\n   *\n   * @returns {module:ui/dropdown/DropdownView}\n   *   The labeled field view class instance.\n   *\n   * @private\n   */\n  _createSelect(label, options = {}) {\n    options.label = label\n    return new _select_js__WEBPACK_IMPORTED_MODULE_2__[\"default\"](this.locale, options);\n  }\n\n  /**\n   * Creates button.\n   *\n   * @param {string} label\n   *   Button label.\n   * @param {module:ui/icon/iconview~IconView} icon\n   *   Button icon.\n   * @param {string} className\n   *   HTML class.\n   *\n   * @returns {module:ui/button/buttonview~ButtonView}\n   *   The button view class instance.\n   *\n   * @private\n   */\n  _createButton( label, icon, className ) {\n    const button = new ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.ButtonView();\n\n    button.set({\n      label,\n      icon,\n      class: className,\n      tooltip: true,\n      withText: true\n    });\n\n    return button;\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/ui/formview.js?")},"./js/ckeditor5_plugins/bbutton/src/ui/option.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ OptionView)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/ui */ \"ckeditor5/src/ui.js\");\n/**\n * @file\n * Defines the OptionView View class.\n */\n\n/**\n * @module bButton/ui/OptionView\n */\n\n\n\n/**\n * The OptionView class.\n *\n * @extends module:ui/view~View\n */\nclass OptionView extends ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.View {\n\n  /**\n   * @inheritDoc\n   */\n  constructor( locale, options ) {\n    super( locale );\n\n    this.setTemplate( {\n      tag: 'option',\n      attributes: {\n        'value': options.value\n      },\n      children: [{ text: options.label } ]\n    });\n\n  }\n\n  /**\n   * @inheritDoc\n   */\n  render() {\n    super.render();\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/ui/option.js?")},"./js/ckeditor5_plugins/bbutton/src/ui/select.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"default\": () => (/* binding */ SelectView)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/ui */ \"ckeditor5/src/ui.js\");\n/* harmony import */ var _option_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./option.js */ \"./js/ckeditor5_plugins/bbutton/src/ui/option.js\");\n/* harmony import */ var _tag_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./tag.js */ \"./js/ckeditor5_plugins/bbutton/src/ui/tag.js\");\n/**\n * @file\n * Defines the SelectView View class.\n */\n\n/**\n * @module bButton/ui/SelectView\n */\n\n\n\n\n\n/**\n * The SelectView class.\n *\n * @extends module:ui/view~View\n */\nclass SelectView extends ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.View {\n\n  /**\n   * @inheritDoc\n   */\n  constructor( locale, options ) {\n    super( locale );\n\n    this.childViewsCollection = this.createCollection();\n\n    this.options = options;\n    for (let elm of options.options) {\n      let option = new _option_js__WEBPACK_IMPORTED_MODULE_1__[\"default\"](locale, { label: elm.label, value: elm.value });\n      this.childViewsCollection.add(option);\n    }\n\n    this.setTemplate({\n      tag: 'div',\n      attributes: {\n        class: [ 'form-item', 'form-item-select-wrapper' ],\n      },\n      children: [\n        new _tag_js__WEBPACK_IMPORTED_MODULE_2__[\"default\"](this.locale, 'label', {\n          text: options.label,\n          attributes: {\n            class: ['form-item__label'],\n          }\n        }),\n        new _tag_js__WEBPACK_IMPORTED_MODULE_2__[\"default\"](this.locale, 'select', {\n          attributes: {\n            class: [ 'form-select', 'form-element', 'form-element--type-select', 'ck', 'ck-input' ],\n          },\n          children: this.childViewsCollection\n        })\n      ]\n    } );\n  }\n\n  /**\n   * Return array valid values\n   */\n  getValidValues() {\n    const validValues = []\n    for (let elm of this.options.options) {\n      validValues.add(elm.value)\n    }\n    return validValues\n  }\n\n  setValue(value) {\n    let elm = this.element.querySelector('select');\n    if (elm) {\n      for (let i = 0; i < elm.options.length; i++) {\n        let optionValue = '';\n        if (elm.options[i].hasAttribute('value')) {\n          optionValue = elm.options[i].value\n        }\n        elm.options[i].selected = optionValue == value;\n      }\n    }\n  }\n\n  getValue() {\n    let elm = this.element.querySelector('select');\n\n    if (elm) {\n      let optionValue = '';\n\n      for (let i = 0; i < elm.options.length; i++) {\n        if (elm.options[i].selected) {\n          if (elm.options[i].hasAttribute('value')) {\n            optionValue = elm.options[i].value\n          }\n          break;\n        }\n      }\n      return optionValue;\n    }\n\n    return null;\n  }\n\n  /**\n   * @inheritDoc\n   */\n  render() {\n    super.render();\n  }\n\n  /**\n   * Focus on the first form element.\n   */\n  focus() {\n    ;\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/ui/select.js?")},"./js/ckeditor5_plugins/bbutton/src/ui/tag.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval('__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   "default": () => (/* binding */ TagView)\n/* harmony export */ });\n/* harmony import */ var ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ckeditor5/src/ui */ "ckeditor5/src/ui.js");\n/**\n * @file\n * Defines the TagView View class.\n */\n\n/**\n * @module bButton/ui/TagView\n */\n\n\n\n/**\n * The TagView class.\n *\n * @extends module:ui/view~View\n */\nclass TagView extends ckeditor5_src_ui__WEBPACK_IMPORTED_MODULE_0__.View {\n\n  /**\n   * @inheritDoc\n   */\n  constructor( locale, tag, options = { attributes : {}}) {\n    super( locale );\n\n    this.setTemplate( {\n      tag,\n      attributes: options.attributes ? options.attributes : {},\n      children: options.children\n      ? options.children\n      : options.text\n        ? [ { text: options.text }]\n        : []\n    });\n\n  }\n\n  /**\n   * @inheritDoc\n   */\n  render() {\n    super.render();\n  }\n\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/ui/tag.js?')},"./js/ckeditor5_plugins/bbutton/src/utils.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   findElement: () => (/* binding */ findElement)\n/* harmony export */ });\n/**\n * @file\n * Defines a helper class and functions.\n */\n\n/**\n * Finds a closest element of a model name in a given selection.\n *\n * @param {module:engine/model/selection~Selection} modelSelection\n *   Model selection.\n *\n * @param {string} modelName\n *   Model name of a searched element.\n *\n * @returns {module:engine/model/element~Element}\n *   Found element.\n */\nfunction findElement(modelSelection, modelName) {\n  const selectedElement = modelSelection.getSelectedElement();\n  if (selectedElement && selectedElement.name == modelName) {\n    return selectedElement;\n  } else {\n    return modelSelection\n      .getFirstRange()\n      .getCommonAncestor()\n      .findAncestor(modelName);\n  }\n}\n\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/ckeditor5_plugins/bbutton/src/utils.js?")},"./js/icons/bb.svg":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval('__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)\n/* harmony export */ });\n/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ("<?xml version=\\"1.0\\" encoding=\\"utf-8\\"?>\\n<svg version=\\"1.1\\" id=\\"Layer_1\\" xmlns=\\"http://www.w3.org/2000/svg\\" xmlns:xlink=\\"http://www.w3.org/1999/xlink\\" x=\\"0px\\" y=\\"0px\\"\\n\\t viewBox=\\"0 0 31 19\\" style=\\"enable-background:new 0 0 31 19;\\" xml:space=\\"preserve\\">\\n<rect x=\\"0.5\\" y=\\"0.5\\" style=\\"fill:#CECECE;stroke:#000000;stroke-miterlimit:10;\\" width=\\"30\\" height=\\"18\\"/>\\n<text transform=\\"matrix(1 0 0 1 9.0665 13.7686)\\" style=\\"font-family:\'MyriadPro-Regular\'; font-size:12px;\\">BB</text>\\n</svg>\\n");\n\n//# sourceURL=webpack://CKEditor5.bbutton/./js/icons/bb.svg?')},"ckeditor5/src/core.js":(module,__unused_webpack_exports,__webpack_require__)=>{eval('module.exports = (__webpack_require__(/*! dll-reference CKEditor5.dll */ "dll-reference CKEditor5.dll"))("./src/core.js");\n\n//# sourceURL=webpack://CKEditor5.bbutton/delegated_./core.js_from_dll-reference_CKEditor5.dll?')},"ckeditor5/src/ui.js":(module,__unused_webpack_exports,__webpack_require__)=>{eval('module.exports = (__webpack_require__(/*! dll-reference CKEditor5.dll */ "dll-reference CKEditor5.dll"))("./src/ui.js");\n\n//# sourceURL=webpack://CKEditor5.bbutton/delegated_./ui.js_from_dll-reference_CKEditor5.dll?')},"dll-reference CKEditor5.dll":e=>{"use strict";e.exports=CKEditor5.dll}},__webpack_module_cache__={};function __webpack_require__(e){var n=__webpack_module_cache__[e];if(void 0!==n)return n.exports;var t=__webpack_module_cache__[e]={exports:{}};return __webpack_modules__[e](t,t.exports,__webpack_require__),t.exports}__webpack_require__.d=(e,n)=>{for(var t in n)__webpack_require__.o(n,t)&&!__webpack_require__.o(e,t)&&Object.defineProperty(e,t,{enumerable:!0,get:n[t]})},__webpack_require__.o=(e,n)=>Object.prototype.hasOwnProperty.call(e,n),__webpack_require__.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})};var __webpack_exports__=__webpack_require__("./js/ckeditor5_plugins/bbutton/src/index.js");return __webpack_exports__=__webpack_exports__.default,__webpack_exports__})()));